import { system, world } from "@minecraft/server"

world.events.worldInitialize.subscribe(()=>{
    world.getDimension(`minecraft:overworld`).runCommandAsync(`gamerule showdeathmessages false`)
    world.getDimension(`minecraft:overworld`).runCommandAsync(`gamerule doimmediaterespawn true`)
    world.getDimension(`minecraft:overworld`).runCommandAsync(`gamerule sendcommandfeedback false`)
})

system.runInterval(()=>{
    let players = world.getAllPlayers()
    for(let player of players){
        //& If health is none, and player has not died nor is dead .
        if(player.getComponent(`minecraft:health`).current==0 && !player.hasTag(`simple.died`) && !player.hasTag(`simple.dead`) ){
            world.sendMessage(player.nameTag+` died §cpermanently§r.`)
            player.onScreenDisplay.setTitle(`§4You Died`)
            player.addTag(`simple.died`)
        }else if(player.hasTag(`simple.died`)){ //& If player has died
            player.runCommandAsync(`execute as @s[m=!spectator] at @s run function hardcore/died`)
        }else if(player.hasTag(`simple.dead`)){ //& If player is  dead
            player.runCommandAsync(`execute as @s[m=!spectator] at @s run function hardcore/undied`)
        }
    }
})


import { ActionFormData, ModalFormData} from "@minecraft/server-ui"

world.events.beforeChat.subscribe((data)=>{
    let player = data.sender
    let msg = data.message
    if(msg==`.ui` && player.hasTag(`simple.dead`)){
        player.addTag(`simple.ui`)
        data.cancel=true;return;
    }
    if(msg==`.ui` && !player.hasTag(`simple.dead`)){
        player.sendMessage(`§4ERROR; §cThis feature is only for the dead`)
        data.cancel=true;return;
    }
    if(player.hasTag(`simple.dead`)){
        data.cancel=true
        world.sendMessage(`§4Dead§f <${player.nameTag}> ${msg}`)
    }
})

system.runInterval(()=>{
    let players = world.getAllPlayers()
    for(let player of players){
        if(player.hasTag(`rebirth`)){player.runCommandAsync(`function hardcore/rebirth`);world.sendMessage(`§a${player.name} has been §areborn`)}

        if(player.hasTag(`simple.ui`)){
            let playersArray = ["none"]
            players.forEach(addToArray)
            function addToArray(e){
                if(!e.hasTag(`simple.dead`)){playersArray.push(e.name)}
            }
            let Mui = new ModalFormData()
            .title(`Teleport to a Player`)
            .dropdown(`Select a Player`,playersArray)
            Mui.show(player).then(r=>{
                if(r.formValues)player.removeTag(`simple.ui`)
                if(r.formValues[0]==0)return;
                player.runCommandAsync(`tp @s ${playersArray[r.formValues[0]]}`)
                player.runCommand(`tellraw @s {"rawtext":[{"text":"§7Teleported to §a${playersArray[result.formValues[0]]}"}]}`)
            })
        }
    }
},20)